#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "dialog.h"

FarDialogItem *MakeFarDialog(char *title,DialogItem *di,int num,UnpackedDialog *out)
{
  FarDialogItem *p,*fdi=(FarDialogItem*)malloc(sizeof(FarDialogItem)*(num+1));
  if (!fdi) return NULL;
  out->xsize=out->ysize=0;
  out->num=num+1;

  for (p=fdi;num--;++di,++p)
  {
    {
      p->Type=di->Type;
      p->X1=di->X1+3;
      p->Y1=di->Y1+2;
      p->X2=p->X1+di->X2;
      p->Y2=p->Y1+di->Y2;
      p->Focus=di->Focus;
      p->Selected=di->Selected;
      p->Flags=di->Flags;
      p->DefaultButton=di->DefaultButton;
      if ((di->Type==DI_TEXT || di->Type==DI_VTEXT) && (di->X2 || di->Y2))
      {
        int sz=di->X2?di->X2:di->Y2;
        memset(p->Data,*di->Data,sz);
        p->Data[sz]=0;
      }
      else
      {
        if ((unsigned int)di->Data<1000)
          strncpy(p->Data,GetMsg((unsigned)di->Data),sizeof(p->Data));
        else
          strncpy(p->Data,di->Data,sizeof(p->Data));
      }

      if (p->X2 > out->xsize) out->xsize=p->X2;
      if (p->Y2 > out->ysize) out->ysize=p->Y2;
    }
  }
  memset(p,0,sizeof(FarDialogItem));
//  *xsize+=1;
  out->ysize+=1;
  p->Type=DI_DOUBLEBOX;
  p->X1=2;
  p->Y1=1;
  p->X2=out->xsize;
  p->Y2=out->ysize;
  strncpy(p->Data,((unsigned)title<1000)?GetMsg((unsigned)title):title,sizeof(p->Data));
  out->xsize+=3;
  out->ysize+=2;
  out->d=fdi;
  return fdi;
}

